2013-08-21	The InnoDB Team

	* buf/buf0buf.c:
	Fix Bug#12560151 61132: infinite loop in buf_page_get_gen()
	when handling compressed pages

2013-08-16	The InnoDB Team

	* row/row0sel.c:
	Fix Bug#17312846 CHECK TABLE ASSERTION FAILURE
	DICT_TABLE_GET_FORMAT(CLUST_INDEX->TABLE) >= 1

2013-08-15	The InnoDB Team

	* row/row0umod.c:
	Fix Bug#17302896 DOUBLE PURGE ON ROLLBACK OF UPDATING
	A DELETE-MARKED RECORD

2013-08-14	The InnoDB Team

	* btr/btr0cur.c, row/row0uins.c:
	Fix Bug#16971045 ASSERTION FAILURES ON ROLLBACK OF AN INSERT AFTER
	A FAILED BLOB WRITE

2013-05-15	The InnoDB Team

	* page/page0zip.c:
	Fix Bug#16736929 PAGE_ZIP_DECOMPRESS() FAILS ON EMPTY RECORD

2013-03-12	The InnoDB Team

	* include/page0zip.ic, page/page0zip.c:
	Fix Bug#16463505 PESSIMISTIC PAGE_ZIP_AVAILABLE()
	MAY CAUSE INFINITE PAGE SPLIT

2013-02-27	The InnoDB Team

	* page/page0zip.c:
	Fix Bug#16400920 INNODB TRIES TO PASS EMPTY BUFFER TO ZLIB,
	GETS Z_BUF_ERROR

2013-01-21	The InnoDB Team

	* buf/buf0buf.c, handler/ha_innodb.cc:
	Fix Bug#16067973 DROP TABLE IS SLOW WHEN IT DECOMPRESSES
	COMPRESSED-ONLY PAGES

2013-01-11	The InnoDB Team
	* row/row0sel.c:
	Fix Bug#16088883 KILLING A QUERY INSIDE INNODB CAUSES IT TO
	EVENTUALLY CRASH WITH AN ASSERTION

2012-12-18	The InnoDB Team

	* include/univ.i:
	Fix Bug#13463493 INNODB PLUGIN WERE CHANGED, BUT STILL USE THE
	SAME VERSION NUMBER 1.0.17

2012-12-13	The InnoDB Team

	* buf/buf0buf.c:
	Fix Bug#14329288 IS THE CALL TO IBUF_MERGE_OR_DELETE_FOR_PAGE FROM
	BUF_PAGE_GET_GEN REDUNDANT?

2012-11-15	The InnoDB Team

	* include/data0type.ic, include/rem0rec.h,
	rem/rem0rec.c, row/row0merge.c:
	Fix Bug#15874001 CREATE INDEX ON A UTF8 CHAR COLUMN FAILS WITH
	ROW_FORMAT=REDUNDANT

2012-10-18	The InnoDB Team

	* row/row0sel.c:
	Fix Bug#14758405: ALTER TABLE: ADDING SERIAL NULL DATATYPE: ASSERTION:
	LEN <= SIZEOF(ULONGLONG)

2012-10-16	The InnoDB Team

	* dict/dict0dict.c, handler/handler0alter.cc, include/dict0dict.h:
	Fix Bug#14729221 IN-PLACE ALTER TABLE REPORTS '' INSTEAD OF REAL
	DUPLICATE VALUE FOR PREFIX KEYS

2012-10-09	The InnoDB Team

	* row/row0mysql.c:
	Fix Bug#14708715 CREATE TABLE MEMORY LEAK ON DB_OUT_OF_FILE_SPACE

2012-09-28	The InnoDB Team

	* include/row0undo.h, row/row0umod.c, row/row0undo.c:
	Fix Bug#13249921 ASSERT !BPAGE->FILE_PAGE_WAS_FREED, USUALLY
	IN TRANSACTION ROLLBACK. This patch will ensure that the
	undo logs will be applied in proper reverse order.

2012-09-18	The InnoDB Team

	* btr/btr0cur.c, handler/ha_innodb.cc, ibuf/ibuf0ibuf.c,
	include/btr0cur.h:
	Fix Bug#14636528 INNODB CHANGE BUFFERING IS NOT ENTIRELY CRASH-SAFE

2012-09-17	The InnoDB Team

	* btr/btr0btr.c, btr/btr0cur.c, buf/buf0lru.c,
	include/page0zip.h, log/log0recv.c, page/page0cur.c,
	page/page0page.c, page/page0zip.c:
	Fix Bug#12701488 ASSERT PAGE_ZIP_VALIDATE, UNIV_ZIP_DEBUG

2012-08-29	The InnoDB Team

	* btr/btr0btr.c, page/page0cur.c, page/page0page.c:
	Fix Bug#14554000 CRASH IN PAGE_REC_GET_NTH_CONST(NTH=0)
	DURING COMPRESSED PAGE SPLIT

2012-08-16	The InnoDB Team

	* btr/btr0cur.c:
	Fix Bug#12595091 POSSIBLY INVALID ASSERTION IN
	BTR_CUR_PESSIMISTIC_UPDATE()

2012-08-16	The InnoDB Team

	* btr/btr0btr.c, btr/btr0cur.c:
	Fix Bug#12845774 OPTIMISTIC INSERT/UPDATE USES WRONG HEURISTICS FOR
	COMPRESSED PAGE SIZE

2012-08-16	The InnoDB Team

	* btr/btr0cur.c, page/page0page.c:
	Fix Bug#13523839 ASSERTION FAILURES ON COMPRESSED INNODB TABLES

2012-08-07	The InnoDB Team

	* btr/btr0pcur.c, row/row0merge.c:
	Fix Bug#14399148 INNODB TABLES UNDER LOAD PRODUCE DUPLICATE COPIES
	OF ROWS IN QUERIES

2012-03-15	The InnoDB Team

	* fil/fil0fil.c, ibuf/ibuf0ibuf.c, include/fil0fil.h,
	lock/lock0lock.c:
	Fix Bug#13825266 RACE IN LOCK_VALIDATE() WHEN ACCESSING PAGES
	DIRECTLY FROM BUFFER POOL

2012-03-15	The InnoDB Team

	* handler/ha_innodb.cc:
	Fix Bug#13851171STRING OVERFLOW IN INNODB CODE FOUND BY STATIC
	ANALYSIS

2012-03-15	The InnoDB Team

	* include/sync0rw.ic:
	Fix Bug#13537504 VALGRIND: COND. JUMP/MOVE DEPENDS ON
	UNINITIALISED VALUES IN OS_THREAD_EQ

2012-03-08	The InnoDB Team

	* btr/btr0pcur.c:
	Fix Bug#13807811 BTR_PCUR_RESTORE_POSITION() CAN SKIP A RECORD

2012-02-28	The InnoDB Team

	* btr/btr0btr.c, dict/dict0dict.c, include/btr0btr.h,
	include/dict0dict.h, include/dict0dict.ic, include/dict0mem.h,
	handler/handler0alter.cc, row/row0mysql.c:
	Fix Bug#12861864 RACE CONDITION IN BTR_GET_SIZE() AND
	DROP INDEX/TABLE/DATABASE

2012-02-15	The InnoDB Team

	* btr/btr0btr.c, btr/btr0cur.c, fsp/fsp0fsp.c, ibuf/ibuf0ibuf.c,
	include/btr0btr.h, include/btr0cur.h, include/btr0cur.ic,
	include/buf0buf.h, include/buf0buf.ic, include/fsp0fsp.h,
	include/mtr0mtr.h, include/mtr0mtr.ic, include/page0page.h,
	include/page0page.ic, include/trx0rec.ic, include/trx0undo.h,
	mtr/mtr0mtr.c, page/page0cur.c, page/page0page.c, row/row0ins.c,
	row/row0row.c, row/row0upd.c, trx/trx0rec.c, trx/trx0sys.c,
	trx/trx0undo.c:
	Fix Bug#13721257 RACE CONDITION IN UPDATES OR INSERTS OF WIDE RECORDS

2012-02-06	The InnoDB Team

	* handler/ha_innodb.cc:
	Fix Bug#11754376 45976: INNODB LOST FILES FOR TEMPORARY TABLES ON
	GRACEFUL SHUTDOWN

2012-01-30	The InnoDB Team

	* fil/fil0fil.c:
	Fix Bug#13636122 THE ORIGINAL TABLE MISSING WHILE EXECUTE THE
	DDL 'ALTER TABLE ADD COLUMN'

2012-01-16	The InnoDB Team

	* ibuf/ibuf0ibuf.c:
	Fix Bug#13496818 ASSERTION: REC_PAGE_NO > 4 IN IBUF CONTRACTION

2012-01-16	The InnoDB Team

	* handler/ha_innodb.cc:
	Fix Bug#11765438: 58406: ISSUES WITH COPYING PARTITIONED INNODB
	TABLES FROM LINUX TO WINDOWS

2012-01-04	The InnoDB Team

	* row/row0mysql.c:
	Fix Bug#12400341: INNODB CAN LEAVE ORPHAN IBD FILES AROUND

2011-12-22	The InnoDB Team

	* row/row0sel.c:
	Fix Bug#63775 Server crash on handler read next after delete record.
2011-12-21	The InnoDB Team

	* include/ut0rnd.ic:
	Fix Bug#11866367:FPE WHEN SETTING INNODB_SPIN_WAIT_DELAY

2011-12-13	The InnoDB Team

	* handler/ha_innodb.cc, innodb.test, innodb.result:
	Fix Bug#13117023: InnoDB was incrementing the handler_read_key,
	also the SSV::ha_read_key_count, at the wrong place.

2011-12-10	The InnoDB Team

	* include/page0page.h, page/page0page.c:
	Fix Bug#13418887 ERROR IN DIAGNOSTIC FUNCTION PAGE_REC_PRINT()

2011-11-10	The InnoDB Team

	* handler/ha_innodb.cc, row/row0ins.c, innodb_replace.test:
	Fix Bug#11759688 52020: InnoDB can still deadlock
	on just INSERT...ON DUPLICATE KEY a.k.a. the reintroduction of
	Bug#7975 deadlock without any locking, simple select and update

2011-11-08	The InnoDB Team

	* btr/btr0pcur.c, include/btr0pcur.h, include/btr0pcur.ic:
	Fix Bug#13358468 ASSERTION FAILURE IN BTR_PCUR_GET_BLOCK

2011-10-27	The InnoDB Team

	* row/row0mysql.c:
	Fix Bug #12884631 62146: TABLES ARE LOST FOR DDL

2011-10-25	The InnoDB Team

	* handler/ha_innodb.cc, row/row0ins.c:
	Fix Bug#13002783 PARTIALLY UNINITIALIZED CASCADE UPDATE VECTOR

2011-10-20	The InnoDB Team

	* btr/btr0cur.c:
	Fix Bug#13116045 Compilation failure using GCC 4.6.1 in btr/btr0cur.c

2011-10-12	The InnoDB Team

	* btr/btr0cur.c, btr/btr0sea.c, buf/buf0buf.c, buf/buf0lru.c,
	ha/ha0ha.c, handler/ha_innodb.cc, ibuf/ibuf0ibuf.c, include/btr0sea.h,
	include/btr0types.h, include/buf0buf.h, include/ha0ha.h,
	include/ha0ha.ic, include/row0upd.ic, include/sync0sync.h,
	page/page0page.c, sync/sync0sync.c:
	Fix Bug#13006367 62487: innodb takes 3 minutes to clean up
	the adaptive hash index at shutdown

2011-10-04	The InnoDB Team

	* include/sync0rw.h, sync/sync0rw.c:
	Fix Bug#13034534 RQG TESTS FAIL ON WINDOWS WITH CRASH NEAR
	RW_LOCK_DEBUG_PRINT

2011-09-20	The InnoDB Team

	* row/row0purge.c:
	Fix Bug#12963823 CRASH IN PURGE THREAD UNDER UNUSUAL CIRCUMSTANCES

2011-09-12	The InnoDB Team

	* row/row0sel.c:
	Fix Bug#12601439 CONSISTENT READ FAILURE IN COLUMN PREFIX INDEX

2011-09-08	The InnoDB Team

	* btr/btr0cur.c, include/page0page.h, include/row0upd.ic:
	Fix Bug#12948130 UNNECESSARY X-LOCKING OF ADAPTIVE HASH INDEX

2011-09-06	The InnoDB Team

	* buf/buf0buddy.c:
	Fix Bug#12950803 62294: BUF_BUDDY_RELOCATE CALLS GETTIMEOFDAY
	WHILE HOLDING BUFFER POOL MUTEX

2011-09-06	The InnoDB Team

	* include/trx0undo.h, trx/trx0rec.c, trx/trx0undo.c:
	Fix Bug#12547647 UPDATE LOGGING COULD EXCEED LOG PAGE SIZE

2011-08-29	The InnoDB Team

	* btr/btr0btr.c, btr/btr0cur.c, fsp/fsp0fsp.c,
	include/btr0btr.h, include/btr0cur.h, include/fsp0fsp.h,
	include/mtr0mtr.h, include/mtr0mtr.ic, mtr/mtr0mtr.c,
	row/row0ins.c, row/row0row.c, row/row0upd.c, trx/trx0undo.c:
	Fix Bug#12704861 Corruption after a crash during BLOB update
	and other regressions from the fix of Bug#12612184

2011-08-15	The InnoDB Team

	* btr/btr0btr.c, btr/btr0cur.c, btr/btr0pcur.c, btr/btr0sea.c,
	dict/dict0crea.c, dict/dict0dict.c, ibuf/ibuf0ibuf.c,
	include/btr0btr.h, include/btr0btr.ic, include/sync0sync.h,
	sync/sync0sync.c:
	Fix Bug#11766591 59733: Possible deadlock when buffered changes
	are to be discarded in buf_page_create()

2011-08-08	The InnoDB Team

	* row/row0sel.c:
	Fix Bug#12835650 VARCHAR maximum length performance impact

2011-08-08	The InnoDB Team

	* handler/ha_innodb.cc:
	Fix Bug#12770537 I_S.TABLES.DATA_LENGTH DOES NOT SHOW ON-DISK SIZE
	FOR COMPRESSED INNODB

2011-07-19	The InnoDB Team

	* buf/buf0buf.c, buf/buf0rea.c, handler/ha_innodb.cc,
	include/buf0buf.h, include/buf0buf.ic, include/srv0srv.h,
	srv/srv0srv.c:
	Fix Bug#12356373 by reintroducing random readahead

2011-06-30	The InnoDB Team

	* row/row0row.c:
	Fix Bug#12637786 Wrong secondary index entries on CHAR and VARCHAR
	columns in ROW_FORMAT=DYNAMIC and ROW_FORMAT=COMPRESSED

2011-06-16	The InnoDB Team

	* btr/btr0cur.c, buf/buf0buddy.c, buf/buf0buf.c, buf/buf0lru.c,
	include/buf0buddy.h, include/buf0buddy.ic, include/buf0buf.h,
	include/buf0buf.ic, include/buf0lru.h, include/buf0types.h:
	Fix Bug#61188 DROP TABLE extremely slow

2011-06-16	The InnoDB Team

	* buf/buf0buddy.c, buf/buf0buf.c, buf/buf0flu.c, buf/buf0lru.c,
	include/buf0buf.h, include/buf0lru.h:
	Fix Bug#61341 buf_LRU_insert_zip_clean can be O(N) on LRU length

2011-06-16	The InnoDB Team

	* page/page0zip.c, rem/rem0rec.c:
	Fix Bug#61191 question about page_zip_available()

2011-06-16	The InnoDB Team

	* btr/btr0btr.c, btr/btr0cur.c, include/btr0btr.h, include/btr0cur.h,
	include/btr0cur.ic, include/buf0buf.h, include/buf0buf.ic,
	include/page0cur.ic, include/page0page.h, include/page0page.ic,
	include/sync0rw.ic, include/sync0sync.h, page/page0cur.c,
	page/page0page.c, row/row0ins.c, row/row0upd.c,
	sync/sync0rw.c, sync/sync0sync.c:
	Fix Bug#12612184 Race condition after btr_cur_pessimistic_update()

2011-06-09	The InnoDB Team
	* btr/btr0cur.c, include/rem0rec.h, include/rem0rec.ic,
	* row/row0row.c, row/row0vers.c, trx/trx0rec.c:
	Instrumentation for Bug#12612184 Race condition in row_upd_clust_rec()

2011-05-19	The InnoDB Team

	* row/row0row.c:
	Fix Bug#12429576 Assertion failure on purge of column prefix index

2011-04-07	The InnoDB Team

	* handler/ha_innodb.cc, handler/ha_innodb.h, handler/handler0alter.cc:
	Fix Bug #52409 Assertion failure: long semaphore wait

2011-04-07	The InnoDB Team

	* handler/ha_innodb.cc, include/trx0trx.h, include/trx0undo.h,
	log/log0log.c, trx/trx0sys.c, trx/trx0trx.c, trx/trx0undo.c:
	Fix Bug #59641 Prepared XA transaction in system after hard crash
	causes future shutdown hang

2011-03-30	The InnoDB Team

	* srv/srv0srv.c, sync/sync0arr.h, sync/sync0arr.c:
	Fix Bug#11877216 InnoDB too eager to commit suicide on a busy server

2011-03-15	The InnoDB Team

	* btr/btr0cur.c, page/page0zip.c:
	Fix Bug#11849231 inflateInit() invoked without initializing all memory

2011-02-28	The InnoDB Team

	* btr/btr0sea.c, buf/buf0buf.c, buf/buf0lru.c:
	Fix Bug#58549 Race condition in buf_LRU_drop_page_hash_for_tablespace()
	and compressed tables

2011-02-15	The InnoDB Team

	* sync/sync0rw.c, innodb_bug59307.test:
	Bug#59307 Valgrind: uninitialized value in
	rw_lock_set_writer_id_and_recursion_flag()

2011-02-14	The InnoDB Team

	* handler/handler0alter.cc:
	Bug#59749 Enabling concurrent reads while creating non-primary
	unique index gives failures

2011-01-31	The InnoDB Team

	* btr/btr0cur.c, include/row0upd.h,
	row/row0purge.c, row/row0umod.c, row/row0upd.c:
	Bug#59230 assert 0 row_upd_changes_ord_field_binary()
	in post-crash rollback or purge

2011-01-27	The InnoDB Team

	* btr/btr0cur.c:
	Bug#59465 btr_estimate_number_of_different_key_vals use
	incorrect offset for external_size

2011-01-27	The InnoDB Team

	* include/trx0trx.h, trx/trx0trx.c:
	Bug#59440 Race condition in XA ROLLBACK and XA COMMIT
	after server restart

2011-01-25	The InnoDB Team

	* row/row0upd.c:
	Bug#59585 Fix 58912 introduces compiler warning
	due to potentially uninitialized variable

2011-01-25	The InnoDB Team

	* mtr/mtr0log.c:
	Bug#59486 Incorrect usage of UNIV_UNLIKELY() in mlog_parse_string()

2011-01-25	The InnoDB Team

	* row/row0vers.c:
	Fix Bug#59464 Race condition in row_vers_build_for_semi_consistent_read

2011-01-25	The InnoDB Team

	* btr/btr0btr.c, btr/btr0cur.c, btr/btr0sea.c,
	buf/buf0buddy.c, buf/buf0buf.c, buf/buf0lru.c,
	include/buf0buf.h, include/buf0buf.ic, include/buf0lru.h,
	mem/mem0mem.c, page/page0zip.c:
	Fix Bug#59707 Unused compression-related parameters
	in buffer pool functions

2011-01-18	The InnoDB Team

	* include/sync0rw.h, sync/sync0arr.c, sync/sync0rw.c:
	Fix Bug#59579 rw_lock_debug_print outputs to stderr, not to
	SHOW ENGINE INNODB STATUS

2011-01-14	The InnoDB Team
	* btr/btr0cur.c, dict/dict0dict.c, handler/ha_innodb.cc,
	include/btr0cur.h, include/dict0mem.h, include/rem0cmp.h,
	include/rem0cmp.ic, include/srv0srv.h, rem/rem0cmp.c,
	srv/srv0srv.c, innodb_bug30423.test:
	Fix Bug#30423 InnoDBs treatment of NULL in index stats causes
	bad "rows examined" estimates

2011-01-06	The InnoDB Team
	* row/row0merge.c:
	Fix Bug#59312 Examine MAX_FULL_NAME_LEN in InnoDB to address
	possible insufficient name buffer

2011-01-06	The InnoDB Team
	* dict/dict0dict.c, handler/ha_innodb.cc, handler/i_s.cc,
	include/univ.i:
	Fix Bug#58643 InnoDB: too long table name

2011-01-06	The InnoDB Team
	* handler/i_s.cc, include/trx0i_s.h, trx/trx0i_s.c:
	Fix Bug#55397 cannot select from innodb_trx when trx_query contains
	blobs that aren't strings

2011-01-04	The InnoDB Team
	* dict/dict0dict.c:
	Fix Bug#59197 double quote in field comment prevents foreign
	key constraint creation

2010-12-21	The InnoDB Team
	* include/btr0cur.h, include/row0upd.h, btr/btr0cur.c,
	row/row0umod.c, row/row0upd.c:
	Fix Bug#55284 Double free of off-page columns due to lock wait
	while updating PRIMARY KEY

2010-12-21	The InnoDB Team

	* include/data0data.h, include/data0data.ic, include/row0upd.h,
	btr/btr0cur.c, row/row0purge.c, row/row0umod.c, row/row0upd.c,
	innodb.result, innodb.test:
	Fix Bug#58912 InnoDB unnecessarily avoids update-in-place
	on column prefix indexes

2010-12-09	The InnoDB Team

	* buf/buf0lru.c:
	Fix Bug#57600 output of I/O sum[%lu] can go negative

2010-11-11	The InnoDB Team

	* thr/thr0loc.c, trx/trx0i_s.c:
	Fix Bug#57802 Empty ASSERTION parameter passed to the HASH_SEARCH macro

2010-11-10	The InnoDB Team

	* dict/dict0dict.c, handler/handler0alter.cc, include/dict0dict.h
	row/row0merge.c:
	Fix Bug#55084 InnoDB crash and corruption after ALTER TABLE

2010-11-10	The InnoDB Team

	* srv/srv0start.c:
	Fix Bug#48026 Log start and end of InnoDB buffer pool
	initialization to the error log

2010-11-03	The InnoDB Team

	* include/btr0btr.h, include/btr0btr.ic, dict/dict0crea.c:
	Fix Bug#57947 InnoDB diagnostics shows btr_block_get calls
	instead of real callers

2010-11-03	The InnoDB Team

	* fil/fil0fil.c, fsp/fsp0fsp.c, handler/ha_innodb.cc,
	include/fil0fil.h, include/univ.i:
	Fix Bug #54538 - use of exclusive innodb dictionary lock limits
	performance.

2010-11-02	The InnoDB Team

	* btr/btr0cur.c, dict/dict0dict.c, dict/dict0load.c,
	handler/ha_innodb.cc, include/dict0dict.h, row/row0mysql.c,
	innodb_bug53046.result, innodb_bug53046.test:
	Fix Bug#53046 dict_update_statistics_low can still be run
	concurrently on same table

2010-11-02	The InnoDB Team

	* row/row0sel.c:
	Fix Bug#57799 READ UNCOMMITTED access failure of off-page
	DYNAMIC or COMPRESSED columns again

2010-10-24	The InnoDB Team

	* row/row0mysql.c
	Fix Bug#57700 Latching order violation in
	row_truncate_table_for_mysql()

2010-10-20	The InnoDB Team

	* dict/dict0load.c
	Fix Bug#57616 Sig 11 in dict_load_table() when failed to load
	index or foreign key

2010-10-19	The InnoDB Team

	* btr/btr0cur.c, buf/buf0buf.c, buf/buf0flu.c, handler/ha_innodb.cc,
	ibuf/ibuf0ibuf.c, include/btr0cur.h, include/buf0flu.h,
	include/ibuf0ibuf.h, include/row0mysql.h,
	row/row0mysql.c, row/row0sel.c,
	innodb_bug56680.test, innodb_bug56680.result:
	Fix Bug#56680 InnoDB may return wrong results from a
	case-insensitive covering index

2010-10-18	The InnoDB Team

	* handler/ha_innodb.cc, handler/ha_innodb.h, innodb_bug57252.result,
	innodb_bug57252.test:
	Fix Bug#57252 disabling innobase_stats_on_metadata disables ANALYZE

2010-10-14	The InnoDB Team

	* handler/ha_innodb.cc, innodb_bug56143.result, innodb_bug56143.test:
	Fix Bug#56143 too many foreign keys causes output of show create
	table to become invalid

2010-10-14	The InnoDB Team

	* srv/srv0start.c:
	Fix Bug#57397 io_handler_thread() will never cleanup

2010-10-11	The InnoDB Team

	* row/row0sel.c
	Fix Bug #57345 btr_pcur_store_position abort for load with
	concurrent lock/unlock tables

2010-10-11	The InnoDB Team

	* row/row0mysql.c, innodb_bug56947.result, innodb_bug56947.test:
	Fix Bug #56947 InnoDB leaks memory when failing to create a table

2010-10-06	The InnoDB Team

	* row/row0mysql.c, innodb_bug57255.result, innodb_bug57255.test
	Fix Bug #57255 Cascade Delete results in "Got error -1 from
	storage engine"

2010-09-27	The InnoDB Team

	* row/row0sel.c, innodb_bug56716.result, innodb_bug56716.test:
	Fix Bug#56716 InnoDB locks a record gap without locking the table

2010-09-06	The InnoDB Team

	* dict/dict0load.c, innodb_bug53756.test innodb_bug53756.result:
	Fix Bug#53756 ALTER TABLE ADD PRIMARY KEY affects crash recovery

2010-08-24	The InnoDB Team

	* handler/ha_innodb.c, dict/dict0dict.c:
	Fix Bug#55832 selects crash too easily when innodb_force_recovery>3

2010-08-03	The InnoDB Team

	* include/dict0dict.h, include/dict0dict.ic, row/row0mysql.c:
	Fix Bug#54678 InnoDB, TRUNCATE, ALTER, I_S SELECT, crash or deadlock

2010-08-03	The InnoDB Team

	* dict/dict0load.c, handler/ha_innodb.cc, include/db0err.h,
	include/dict0load.h, include/dict0mem.h, include/que0que.h,
	row/row0merge.c, row/row0mysql.c:
	Fix Bug#54582 stack overflow when opening many tables linked
	with foreign keys at once

2010-08-03	The InnoDB Team

	* include/ut0mem.h, ut/ut0mem.c:
	Fix Bug#55627 segv in ut_free pars_lexer_close innobase_shutdown
	innodb-use-sys-malloc=0

2010-08-01	The InnoDB Team

	* handler/ha_innodb.cc:
	Fix Bug#55382 Assignment with SELECT expressions takes unexpected
	S locks in READ COMMITTED

2010-07-27	The InnoDB Team

	* include/mem0pool.h, mem/mem0mem.c, mem/mem0pool.c, srv/srv0start.c:
	Fix Bug#55581 shutdown with innodb-use-sys-malloc=0: assert
	mutex->magic_n == MUTEX_MAGIC_N.

2010-06-30	The InnoDB Team

	* btr/btr0sea.c, ha/ha0ha.c, handler/ha_innodb.cc, include/btr0sea.h:
	Fix Bug#54311 Crash on CHECK PARTITION after concurrent LOAD DATA
	and adaptive_hash_index=OFF

2010-06-29	The InnoDB Team
	* row/row0row.c, row/row0undo.c, row/row0upd.c:
	Fix Bug#54408 txn rollback after recovery: row0umod.c:673
	dict_table_get_format(index->table)

2010-06-29	The InnoDB Team

	* btr/btr0cur.c, include/btr0cur.h, include/row0mysql.h,
	row/row0merge.c, row/row0sel.c:
	Fix Bug#54358 READ UNCOMMITTED access failure of off-page DYNAMIC
	or COMPRESSED columns

2010-06-24	The InnoDB Team

	* handler/ha_innodb.cc:
	Fix Bug#54679 alter table causes compressed row_format to revert
	to compact

2010-06-22	The InnoDB Team

	* dict/dict0dict.c, dict/dict0mem.c, include/dict0mem.h,
	include/univ.i, page/page0zip.c, row/row0merge.c:
	Fix Bug#47991 InnoDB Dictionary Cache memory usage increases
	indefinitely when renaming tables

2010-06-22	The InnoDB Team

	* handler/ha_innodb.cc:
	Fix Bug#54686: "field->col->mtype == type" assertion error at
	row/row0sel.c

2010-06-22	The InnoDB Team

	* handler/ha_innodb.cc, innodb_bug54044.result, innodb_bug54044.test:
	Fix Bug#54044 Create temporary tables and using innodb crashes.

2010-06-21	The InnoDB Team

	* dict/dict0load.c, fil/fil0fil.c:
	Fix Bug#54658: InnoDB: Warning: allocated tablespace %lu,
	old maximum was 0 (introduced in Bug#53578 fix)

2010-06-16	The InnoDB Team

	* row/row0merge.c:
	Fix Bug#54330 Broken fast index creation

2010-06-10	The InnoDB Team

	* include/log0log.ic, row/row0ins.c, row/row0purge.c,
	row/row0uins.c, row/row0umod.c, row/row0upd.c:
	Fix Bug#39168 ERROR: the age of the last checkpoint ... exceeds
	the log group capacity

2010-06-08	The InnoDB Team

	* dict/dict0load.c:
	Fix Bug#54009 Server crashes when data is selected from non backed
	up table for InnoDB plugin

2010-06-02	The InnoDB Team

	* include/db0err.h, include/lock0lock.h, include/row0mysql.h,
	lock/lock0lock.c, row/row0ins.c, row/row0mysql.c, row/row0sel.c:
	Fix Bug#53674 InnoDB: Error: unlock row could not find a
	4 mode lock on the record

2010-06-01	The InnoDB Team

	* include/sync0rw.h, sync/sync0rw.c:
	Fix Bug#48197 Concurrent rw_lock_free may cause assertion failure

2010-06-01	The InnoDB Team

	* row/row0umod.c:
	Fix Bug#53812 assert row/row0umod.c line 660 in txn rollback
	after crash recovery

2010-05-25	The InnoDB Team

	* handler/ha_innodb.cc, include/row0mysql.h, row/row0mysql.c:
	Fix Bug#53592: crash replacing duplicates into table after fast
	alter table added unique key

2010-05-24	The InnoDB Team

	* dict/dict0boot.c, dict/dict0crea.c, fil/fil0fil.c,
	include/dict0boot.h, include/fil0fil.h, row/row0mysql.c:
	Fix Bug#53578: assert on invalid page access, in fil_io()

2010-05-14	The InnoDB Team
	* mysql-test/innodb_bug48024.test, mysql-test/innodb_bug48024.result,
	dict/dict0dict.c, handler/ha_innodb.cc, handler/ha_innodb.h,
	include/dict0dict.h, include/ha_prototypes.h, include/row0mysql.h,
	include/trx0trx.h, row/row0mysql.c, trx/trx0i_s.c, trx/trx0trx.c:
	Fix Bug#48024 Innodb doesn't work with multi-statements
	Fix Bug#53644 InnoDB thinks that /*/ starts and ends a comment

2010-05-12	The InnoDB Team

	* handler/handler0alter.cc:
	Fix Bug#53591 crash with fast alter table and text/blob prefix
	primary key

2010-05-12	The InnoDB Team

	* row/row0merge.c:
	Fix Bug#53471 row_merge_drop_temp_indexes() refers freed memory, SEGVs

2010-05-11	The InnoDB Team

	* mysql-test/innodb_bug53290.test, mysql-test/innodb_bug53290.result,
	include/rem0cmp.h, rem/rem0cmp.c, row/row0merge.c:
	Fix Bug#53290 wrong duplicate key error when adding a unique index
	via fast alter table

2010-05-11	The InnoDB Team
	* buf/buf0lru.c, include/buf0buf.ic:
	Fix Bug#53307 valgrind: warnings in main.partition_innodb_plugin

2010-05-05	The InnoDB Team

	* row/row0merge.c:
	Fix Bug#53256 in a stress test, assert dict/dict0dict.c:815
	table2 == NULL

2010-05-05	The InnoDB Team

	* handler/ha_innodb.cc:
	Fix Bug#53165 Setting innodb_change_buffering=DEFAULT produces
	incorrect result

2010-05-04	The InnoDB Team

	* fsp/fsp0fsp.c:
	Fix Bug#53306 valgrind: warnings in innodb.innodb

2010-05-03	The InnoDB Team

	* buf0buf.c:
	Fix Bug#53248 compressed tables page checksum mismatch after
	re-enabling innodb_checksums

2010-04-28	The InnoDB Team

	* log/log0recv.h, log/log0recv.c:
	Fix Bug#53122 InnoDB recovery uses too big a hash table for redo
	log records

2010-04-27	The InnoDB Team

	* handler/ha_innodb.cc, lock/lock0lock.c, row/row0mysql.c,
	row/row0sel.c:
	Fix Bug#48607 READ UNCOMMITTED uses more locks than READ COMMITTED
	in InnoDB 5.1+

2010-04-26	The InnoDB Team

	* row/row0sel.c:
	Fix Bug#52663 Lost update incrementing column value under
	READ COMMITTED isolation level

2010-04-22	The InnoDB Team

	* include/dict0boot.h, dict/dict0boot.c:
	Fix a bug that prevented the crash recovery of fast CREATE INDEX
	from dropping partially created indexes.

2010-04-21	The InnoDB Team

	* btr/btr0btr.c:
	Fix Bug#52964 Infinite loop in btr_page_split_and_insert()
	in ROW_FORMAT=COMPRESSED

2010-04-21	The InnoDB Team

	* data/data0data.c:
	Fix Bug#52745 Failing assertion: blob_no < page_zip->n_blobs

2010-04-20	The InnoDB Team

	* dict/dict0crea.c, handler/ha_innodb.cc, include/trx0trx.h:
	Fix Bug#50495 'Row size too large' for plugin, but works for
	built-in InnoDB
	Only check the record size at index creation time when
	innodb_strict_mode is set or when ROW_FORMAT is DYNAMIC or COMPRESSED.

2010-04-15	The InnoDB Team

	* trx/trx0rec.c:
	Fix Bug#52746 InnoDB purge thread crashed with table containing
	prefix indexed blobs

2010-03-31	The InnoDB Team

	* mysql-test/innodb_bug51920.test, mysql-test/innodb_bug51920.result,
	srv/srv0srv.c:
	Fix Bug#51920 InnoDB connections in row lock wait ignore KILL
	until lock wait timeout

2010-03-31	The InnoDB Team

	* mysql-test/innodb_bug38231.test:
	Remove non-determinism in the test case.

2010-03-29	The InnoDB Team

	InnoDB Plugin 1.0.7 released

2010-03-18	The InnoDB Team

	* CMakeLists.txt:
	Fix Bug#52102 InnoDB Plugin shows performance drop compared to
	InnoDB (Windows)

2010-03-18	The InnoDB Team

	* buf0buf.ic:
	When comparing the time of the first access to a block against
	innodb_old_blocks_time, use 32-bit arithmetics. The comparison was
	incorrect on 64-bit systems.

2010-03-11	The InnoDB Team

	* buf0buf.h, buf0buf.ic:
	Fix and clarify the latching of some buf_block_t members.
	Note that check_index_page_at_flush is not protected by any mutex.
	Note and assert that lock_hash_val is protected by the rw-latch.

2010-03-10	The InnoDB Team

	* trx/trx0sys.c:
	Fix Bug#51653 outdated reference to set-variable

2010-03-10	The InnoDB Team

	* handler/ha_innodb.cc, mysql-test/innodb_bug21704.result,
	mysql-test/innodb_bug47621.result, mysql-test/innodb_bug47621.test:
	Fix Bug#47621 MySQL and InnoDB data dictionaries will become out of
	sync when renaming columns

2010-03-10	The InnoDB Team

	* handler/ha_innodb.cc:
	Fix Bug#51356 Many Valgrind errors in error messages
	with concurrent DDL

2010-03-10	The InnoDB Team

	* handler/ha_innodb.cc, handler/handler0alter.cc,
	mysql-test/innodb_bug51378.result, mysql-test/innodb_bug51378.test:
	Fix Bug#51378 Init 'ref_length' to correct value, in case an out
	of bound MySQL primary_key

2010-03-10	The InnoDB Team

	* log/log0recv.c:
	Remove a bogus assertion about page numbers exceeding 0x90000000
	in the redo log. Abort when encountering a corrupted redo log
	record, unless innodb_force_recovery is set.

2010-03-09	The InnoDB Team

	* handler/ha_innodb.cc:
	Make SHOW ENGINE INNODB MUTEX STATUS display SUM(os_waits)
	for the buffer pool block mutexes and locks.

2010-03-08	The InnoDB Team

	* fil/fil0fil.c:
	Fix ALTER TABLE ... IMPORT TABLESPACE of compressed tables.

2010-03-03	The InnoDB Team

	* handler/handler0alter.cc, innodb-index.result, innodb-index.test,
	innodb.result, innodb.test:
	Disallow a duplicate index name when creating an index.

2010-02-11	The InnoDB Team

	* include/mem0mem.h, include/mem0mem.ic, mem/mem0mem.c:
	Fix Bug#49535 Available memory check slows down crash
	recovery tens of times

2010-02-09	The InnoDB Team

	* buf/buf0buf.c:
	Fix Bug#38901 InnoDB logs error repeatedly when trying to load
	page into buffer pool

2010-02-09	The InnoDB Team

	* srv/srv0srv.c:
	Let the master thread sleep if the amount of work to be done is
	calibrated as taking less than a second.

2010-02-04	The InnoDB Team

	* btr/btr0btr.c, btr/btr0cur.c, btr/btr0pcur.c, buf/buf0buf.c,
	include/btr0btr.h, include/btr0cur.h, include/btr0pcur.h,
	include/btr0pcur.ic, include/buf0buf.h, row/row0ins.c, row/row0sel.c:
	Pass the file name and line number of the caller of the
	b-tree cursor functions to the buffer pool requests, in order
	to make the latch diagnostics more accurate.

2010-02-03	The InnoDB Team

	* lock/lock0lock.c:
	Fix Bug#49001 SHOW INNODB STATUS deadlock info incorrect
	when deadlock detection aborts

2010-02-03	The InnoDB Team

	* buf/buf0lru.c:
	Fix Bug#35077 Very slow DROP TABLE (ALTER TABLE, OPTIMIZE TABLE)
	on compressed tables

2010-02-03	The InnoDB Team

	* handler/ha_innodb.cc, include/row0mysql.h, row/row0mysql.c:
	Clean up CHECK TABLE error handling.

2010-02-01	The InnoDB Team

	* handler/ha_innodb.cc, mysql-test/innodb-autoinc.test,
	mysql-test/innodb-autoinc.result,
	mysql-test/innodb-autoinc-44030.test,
	mysql-test/innodb-autoinc-44030.result:
	Fix Bug#49497 Error 1467 (ER_AUTOINC_READ_FAILED) on inserting
	a negative value

2010-01-28	The InnoDB Team
	*  handler/ha_innodb.h, handler/ha_innodb.cc,
	handler/handler0alter.cc,
	mysql-test/innodb_bug47622.test,
	mysql-test/innodb_bug47622.result:
	Fix Bug#47622 the new index is added before the existing ones
	in MySQL, but after one in SE

2010-01-27	The InnoDB Team

	* include/row0mysql.h, log/log0recv.c, row/row0mysql.c:
	Drop temporary tables at startup.
	This addresses the third aspect of
	Bug#41609 Crash recovery does not work for InnoDB temporary tables.

2010-01-21	The InnoDB Team

	* buf/buf0buf.c:
	Do not merge buffered inserts to compressed pages before
	the redo log has been applied in crash recovery.

2010-01-13	The InnoDB Team

	* row/row0sel.c:
	On the READ UNCOMMITTED isolation level, do not attempt to access
	a clustered index record that has been marked for deletion. The
	built-in InnoDB in MySQL 5.1 and earlier would attempt to retrieve
	a previous version of the record in this case.

2010-01-13	The InnoDB Team

	* buf/buf0buf.c:
	When disabling the adaptive hash index, check the block state
	before checking block->is_hashed, because the latter may be
	uninitialized right after server startup.

2010-01-12	The InnoDB Team

	* handler/ha_innodb.cc, handler/ha_innodb.h:
	Fix Bug#46193 crash when accessing tables after enabling
	innodb_force_recovery option

2010-01-12	The InnoDB Team

	* row/row0mysql.c:
	Fix Bug#49238 Creating/Dropping a temporary table while at 1023
	transactions will cause assert.

2009-12-02	The InnoDB Team

	* srv/srv0start.c:
	Display the zlib version number at startup.
	InnoDB compressed tables use zlib, and the implementation depends
	on the zlib function compressBound(), whose definition was slightly
	changed in zlib version 1.2.3.1 in 2006. MySQL bundles zlib 1.2.3
	from 2005, but some installations use a more recent zlib.

2009-11-30	The InnoDB Team

	* dict/dict0crea.c, dict/dict0mem.c, dict/dict0load.c,
	dict/dict0boot.c, fil/fil0fil.c, handler/ha_innodb.cc,
	include/dict0mem.h, row/row0mysql.c:
	Fix the bogus warning messages for non-existing temporary
	tables that were reported in
	Bug#41609 Crash recovery does not work for InnoDB temporary tables.
	The actual crash recovery bug was corrected on 2009-04-29.

2009-11-27	The InnoDB Team

	InnoDB Plugin 1.0.6 released

2009-11-20	The InnoDB Team

	* handler/ha_innodb.cc:
	Add a workaround to prevent a crash due to Bug#45961 DDL on
	partitioned innodb tables leaves data dictionary in an inconsistent
	state

2009-11-19	The InnoDB Team

	* btr/btr0btr.c:
	Fix Bug#48469 when innodb tablespace is configured too small, crash
	and corruption!

2009-11-19	The InnoDB Team

	* data/data0type.c:
	Fix Bug#48526 Data type for float and double is incorrectly reported
	in InnoDB table monitor

2009-11-19	The InnoDB Team

	* CMakeLists.txt:
	Fix Bug#48317 cannot build innodb as static library

2009-11-18	The InnoDB Team

	* handler/handler0alter.cc:
	Fix Bug#48782 On lock wait timeout, CREATE INDEX (creating primary key)
	attempts DROP TABLE

2009-11-17	The InnoDB Team

	* handler/ha_innodb.cc, mysql-test/innodb.result,
	mysql-test/innodb.test, mysql-test/innodb_bug44369.result,
	mysql-test/innodb_bug44369.test, mysql-test/patches/innodb-index.diff,
	row/row0mysql.c:
	Report duplicate table names to the client connection, not to the
	error log.

2009-11-12	The InnoDB Team

	* handler/ha_innodb.cc, include/db0err.h, row/row0merge.c,
	row/row0mysql.c:
	Allow CREATE INDEX to be interrupted.
	Also, when CHECK TABLE is interrupted, report ER_QUERY_INTERRUPTED.

2009-11-11	The InnoDB Team

	* handler/ha_innodb.cc, mysql-test/innodb_bug47167.result,
	mysql-test/innodb_bug47167.test, mysql-test/innodb_file_format.result:
	Fix Bug#47167 "set global innodb_file_format_check" cannot set value
	by User-Defined Variable

2009-11-11	The InnoDB Team

	* include/os0file.h, os/os0file.c:
	Fix Bug#3139 Mysql crashes: 'windows error 995' after several selects
	on a large DB

2009-11-04	The InnoDB Team

	* handler/ha_innodb.cc:
	Fix Bug#32430 'show innodb status' causes errors
	Invalid (old?) table or database name in logs

2009-11-02	The InnoDB Team

	* btr/btr0sea.c, buf/buf0buf.c, dict/dict0dict.c, fil/fil0fil.c,
	ibuf/ibuf0ibuf.c, include/btr0sea.h, include/dict0dict.h,
	include/fil0fil.h, include/ibuf0ibuf.h, include/lock0lock.h,
	include/log0log.h, include/log0recv.h, include/mem0mem.h,
	include/mem0pool.h, include/os0file.h, include/pars0pars.h,
	include/srv0srv.h, include/thr0loc.h, include/trx0i_s.h,
	include/trx0purge.h, include/trx0rseg.h, include/trx0sys.h,
	include/trx0undo.h, include/usr0sess.h, lock/lock0lock.c,
	log/log0log.c, log/log0recv.c, mem/mem0dbg.c, mem/mem0pool.c,
	os/os0file.c, os/os0sync.c, os/os0thread.c, pars/lexyy.c,
	pars/pars0lex.l, que/que0que.c, srv/srv0srv.c, srv/srv0start.c,
	sync/sync0arr.c, sync/sync0sync.c, thr/thr0loc.c, trx/trx0i_s.c,
	trx/trx0purge.c, trx/trx0rseg.c, trx/trx0sys.c, trx/trx0undo.c,
	usr/usr0sess.c, ut/ut0mem.c:
	Fix Bug#45992 innodb memory not freed after shutdown
	Fix Bug#46656 InnoDB plugin: memory leaks (Valgrind)

2009-10-29	The InnoDB Team

	* handler/ha_innodb.cc, mysql-test/innodb-autoinc.result,
	mysql-test/innodb-autoinc.test:
	Fix Bug#47125 auto_increment start value is ignored if an index is
	created and engine=innodb

2009-10-29	The InnoDB Team

	* handler/ha_innodb.cc, mysql-test/innodb_bug47777.result,
	mysql-test/innodb_bug47777.test:
	Fix Bug#47777 innodb dies with spatial pk: Failing assertion: buf <=
	original_buf + buf_len

2009-10-29	The InnoDB Team

	* handler/ha_innodb.cc:
	Fix Bug#38996 Race condition in ANALYZE TABLE

2009-10-29	The InnoDB Team

	* handler/ha_innodb.cc:
	Fix bug#42383: Can't create table 'test.bug39438'

2009-10-29	The InnoDB Team

	* os/os0proc.c:
	Fix Bug#48237 Error handling in os_mem_alloc_large appears to
	be incorrect

2009-10-29	The InnoDB Team

	* buf/buf0buf.c, buf/buf0lru.c, include/buf0buf.h, include/buf0buf.ic:
	Fix corruption of the buf_pool->LRU_old list and improve debug
	assertions.

2009-10-28	The InnoDB Team

	* srv/srv0start.c:
	Fix Bug#41490 After enlargement of InnoDB page size, the error message
	become inaccurate

2009-10-26	The InnoDB Team

	* row/row0ins.c:
	When allocating a data tuple, zero out the system fields in order
	to avoid Valgrind warnings about uninitialized fields in
	dtuple_validate().

2009-10-22	The InnoDB Team

	* handler/ha_innodb.cc, mysql-test/innodb-zip.result,
	mysql-test/innodb-zip.test, mysql-test/innodb_bug44369.result,
	mysql-test/innodb_bug44369.test:
	Fix Bug#47233 Innodb calls push_warning(MYSQL_ERROR::WARN_LEVEL_ERROR)

2009-10-19	The InnoDB Team

	* mysql-test/innodb_information_schema.test:
	Fix Bug#47808 innodb_information_schema.test fails when run under
	valgrind

2009-10-15	The InnoDB Team

	* include/page0page.ic:
	Fix Bug#47058 Failure to compile innodb_plugin on solaris 10u7 + spro
	cc/CC 5.10

2009-10-13	The InnoDB Team

	* buf/buf0flu.c:
	Call fsync() on datafiles after a batch of pages is written to disk
	even when skip_innodb_doublewrite is set.

2009-10-05	The InnoDB Team

	* buf/buf0buf.c:
	Do not invalidate buffer pool while an LRU batch is active. Added code
	to buf_pool_invalidate() to wait for the running batches to finish.

2009-10-01	The InnoDB Team

	* handler/ha_innodb.cc:
	Fix Bug#47763 typo in error message: Failed to open table %s after %lu
	attemtps.

2009-10-01	The InnoDB Team

	* fsp/fsp0fsp.c, row/row0merge.c:
	Clean up after a crash during DROP INDEX. When InnoDB crashes
	while dropping an index, ensure that the index will be completely
	dropped during crash recovery. The MySQL .frm file may still
	contain the dropped index, but there is little that we can do
	about it.

2009-09-28	The InnoDB Team

	* handler/ha_innodb.cc:
	When a secondary index exists in the MySQL .frm file but not in
	the InnoDB data dictionary, return an error instead of letting an
	assertion fail in index_read.

2009-09-28	The InnoDB Team

	* btr/btr0btr.c, buf/buf0buf.c, include/page0page.h,
	include/page0zip.h, page/page0cur.c, page/page0page.c,
	page/page0zip.c:
	Do not write to PAGE_INDEX_ID when restoring an uncompressed page
	after a compression failure. The field should only be written
	when creating a B-tree page. This fix addresses a race condition
	in a debug assertion.

2009-09-28	The InnoDB Team

	* fil/fil0fil.c:
	Try to prevent the reuse of tablespace identifiers after InnoDB
	has crashed during table creation. Also, refuse to start if files
	with duplicate tablespace identifiers are encountered.

2009-09-25	The InnoDB Team

	* include/os0file.h, os/os0file.c:
	Fix Bug#47055 unconditional exit(1) on ERROR_WORKING_SET_QUOTA
	1453 (0x5AD) for InnoDB backend

2009-09-19	The InnoDB Team

	* handler/ha_innodb.cc, mysql-test/innodb-consistent-master.opt,
	mysql-test/innodb-consistent.result,
	mysql-test/innodb-consistent.test:
	Fix Bug#37232 Innodb might get too many read locks for DML with
	repeatable-read

2009-09-19	The InnoDB Team

	* fsp/fsp0fsp.c:
	Fix Bug#31183 Tablespace full problems not reported in error log,
	error message unclear

2009-09-17	The InnoDB Team

	* mysql-test/innodb-zip.result, mysql-test/innodb-zip.test:
	Make the test pass with zlib 1.2.3.3. Apparently, the definition
	of compressBound() has changed between zlib versions, and the
	maximum record size of a table with 1K compressed page size has
	been reduced by one byte. This is an arbitrary test. In practical
	applications, for good write performance, the compressed page size
	should be chosen to be bigger than the absolute minimum.

2009-09-16	The InnoDB Team

	* handler/ha_innodb.cc:
	Fix Bug#46256 drop table with unknown collation crashes innodb

2009-09-16	The InnoDB Team

	* dict/dict0dict.c, handler/ha_innodb.cc,
	mysql-test/innodb_bug44369.result, mysql-test/innodb_bug44369.test,
	row/row0mysql.c:
	Fix Bug#44369 InnoDB: Does not uniformly disallow disallowed column
	names

2009-09-16	The InnoDB Team

	* handler/ha_innodb.cc, include/db0err.h,
	mysql-test/innodb_bug46000.result, mysql-test/innodb_bug46000.test:
	Fix Bug#46000 using index called GEN_CLUST_INDEX crashes server

2009-09-02	The InnoDB Team

	* include/lock0lock.h, include/row0mysql.h, lock/lock0lock.c,
	row/row0mysql.c:
	Fix a regression introduced by the fix for MySQL bug#26316. We check
	whether a transaction holds any AUTOINC locks before we acquire
	the kernel mutex and release those locks.

2009-08-27	The InnoDB Team

	* dict/dict0dict.c, include/dict0dict.h,
	mysql-test/innodb_bug44571.result, mysql-test/innodb_bug44571.test:
	Fix Bug#44571 InnoDB Plugin crashes on ADD INDEX

2009-08-27	The InnoDB Team

	* row/row0merge.c:
	Fix a bug in the merge sort that can corrupt indexes in fast index
	creation. Add some consistency checks. Check that the number of
	records remains constant in every merge sort pass.

2009-08-27	The InnoDB Team

	* buf/buf0buf.c, buf/buf0lru.c, buf/buf0rea.c, handler/ha_innodb.cc,
	include/buf0buf.h, include/buf0buf.ic, include/buf0lru.h,
	include/ut0ut.h, ut/ut0ut.c:
	Make it possible to tune the buffer pool LRU eviction policy to be
	more resistant against index scans. Introduce the settable global
	variables innodb_old_blocks_pct and innodb_old_blocks_time for
	controlling the buffer pool eviction policy. The parameter
	innodb_old_blocks_pct (5..95) controls the desired amount of "old"
	blocks in the LRU list. The default is 37, corresponding to the
	old fixed ratio of 3/8. Each time a block is accessed, it will be
	moved to the "new" blocks if its first access was at least
	innodb_old_blocks_time milliseconds ago (default 0, meaning every
	block). The idea is that in index scans, blocks will be accessed
	a few times within innodb_old_blocks_time, and they will remain in
	the "old" section of the LRU list. Thus, when innodb_old_blocks_time
	is nonzero, blocks retrieved for one-time index scans will be more
	likely candidates for eviction than blocks that are accessed in
	random patterns.

2009-08-26	The InnoDB Team

	* handler/ha_innodb.cc, os/os0file.c:
	Fix Bug#42885 buf_read_ahead_random, buf_read_ahead_linear counters,
	thread wakeups

2009-08-20	The InnoDB Team

	* lock/lock0lock.c:
	Fix Bug#46650 Innodb assertion autoinc_lock == lock in
	lock_table_remove_low on INSERT SELECT

2009-08-13	The InnoDB Team

	* handler/handler0alter.cc:
	Fix Bug#46657 InnoDB plugin: invalid read in index_merge_innodb test
	(Valgrind)

2009-08-11	The InnoDB Team

	InnoDB Plugin 1.0.4 released

2009-07-20	The InnoDB Team

	* buf/buf0rea.c, handler/ha_innodb.cc, include/srv0srv.h,
	srv/srv0srv.c:
	Change the read ahead parameter name to innodb_read_ahead_threshold.
	Change the meaning of this parameter to signify the number of pages
	that must be sequentially accessed for InnoDB to trigger a readahead
	request.

2009-07-20	The InnoDB Team

	* handler/ha_innodb.cc:
	Fix Bug#39802 On Windows, 32-bit time_t should be enforced

2009-07-16	The InnoDB Team

	* include/univ.i:
	Support inlining of functions and prefetch with Sun Studio.
	These changes are based on contribution from Sun Microsystems Inc.
	under a BSD license.

2009-07-14	The InnoDB Team

	* fil/fil0fil.c:
	Fix Bug#45814 URL reference in InnoDB server errors needs adjusting to
	match documentation

2009-07-14	The InnoDB Team

	* handler/ha_innodb.cc, mysql-test/innodb_bug21704.result,
	mysql-test/innodb_bug21704.test:
	Fix Bug#21704 Renaming column does not update FK definition

2009-07-10	The InnoDB Team

	* handler/ha_innodb.cc, srv/srv0srv.c:
	Change the defaults for
	innodb_sync_spin_loops: 20 -> 30
	innodb_spin_wait_delay: 5 -> 6

2009-07-08	The InnoDB Team

	* buf/buf0flu.c, handler/ha_innodb.cc, include/buf0flu.h,
	include/log0log.h, include/log0log.ic, include/srv0srv.h,
	srv/srv0srv.c:
	Implement the adaptive flushing of dirty pages, which uses
	a heuristics based flushing rate of dirty pages to avoid IO
	bursts at checkpoint. Expose new configure knob
	innodb_adaptive_flushing to control whether the new flushing
	algorithm should be used.

2009-07-07	The InnoDB Team

	* handler/ha_innodb.cc, include/srv0srv.h, log/log0log.c,
	srv/srv0srv.c:
	Implement IO capacity tuning. Expose new configure knob
	innodb_io_capacity to control the master threads IO rate. The
	ibuf merge is also changed from synchronous to asynchronous.
	These changes are based on contribution from Google Inc.
	under a BSD license.

2009-07-02	The InnoDB Team

	* include/ut0ut.h, plug.in, ut/ut0ut.c:
	Use the PAUSE instruction inside the spinloop if it is available,
	Thanks to Mikael Ronstrom <mikael@mysql.com>.

2009-06-29	The InnoDB Team

	* handler/ha_innodb.cc, mysql-test/innodb_file_format.test,
	mysql-test/innodb_file_format.result:
	Do not crash on SET GLOBAL innodb_file_format=DEFAULT
	or SET GLOBAL innodb_file_format_check=DEFAULT.

2009-06-29	The InnoDB Team

	* buf/buf0buf.c, buf/buf0rea.c, lock/lock0lock.c:
	Tolerate missing tablespaces during crash recovery and when
	printing information on locks.

2009-06-29	The InnoDB Team

	* buf/buf0buf.c:
	Fix a race condition when reading buf_fix_count.
	Currently, it is not being protected by the buffer pool mutex,
	but by the block mutex.

2009-06-29	The InnoDB Team

	* handler/handler0alter.cc:
	Start the user transaction prebuilt->trx if it was not started
	before adding or dropping an index. Without this fix, the
	table could be locked outside an active transaction.

2009-06-25	The InnoDB Team

	* handler/ha_innodb.cc, mysql-test/innodb_bug42101.test,
	mysql-test/innodb_bug42101.result,
	mysql-test/innodb_bug42101-nonzero.test,
	mysql-test/innodb_bug42101-nonzero.result:
	Fix Bug#45749 Race condition in SET GLOBAL
	innodb_commit_concurrency=DEFAULT

2009-06-25	The InnoDB Team

	* dict/dict0dict.c:
	When an index column cannot be found in the table during index
	creation, display additional diagnostic before an assertion failure.
	This does NOT fix Bug#44571 InnoDB Plugin crashes on ADD INDEX,
	but it helps understand the reason of the crash.

2009-06-17	The InnoDB Team

	* row/row0merge.c:
	Fix Bug#45426 UNIV_DEBUG build cause assertion error at CREATE INDEX

2009-06-17	The InnoDB Team

	* mysql-test/innodb_bug45357.result, mysql-test/innodb_bug45357.test,
	row/row0mysql.c:
	Fix Bug#45357 5.1.35 crashes with Failing assertion: index->type &
	DICT_CLUSTERED

2009-06-17	The InnoDB Team

	* handler/ha_innodb.cc, mysql-test/innodb-autoinc.result,
	mysql-test/innodb-autoinc.test:
	Fix Bug#44030 Error: (1500) Couldn't read the MAX(ID) autoinc value
	from the index (PRIMARY)

2009-06-11	The InnoDB Team

	* handler/ha_innodb.cc, mysql-test/innodb.result, srv/srv0srv.c:
	Change the following defaults:
	max_dirty_pages_pct: from 90 to 75, max allowed from 100 to 99
	additional_mem_pool_size: from 1 to 8 MB
	buffer_pool_size: from 8 to 128 MB
	log_buffer_size: from 1 to 8 MB
	read_io_threads/write_io_threads: from 1 to 4

2009-06-09	The InnoDB Team

	* handler/ha_innodb.cc, include/trx0trx.h, trx/trx0trx.c:
	Enable Group Commit functionality that was broken in 5.0 when
	distributed transactions were introduced.

2009-06-05	The InnoDB Team

	* handler/ha_innodb.cc, include/os0file.h, include/srv0srv.h,
	os/os0file.c, srv/srv0srv.c, srv/srv0start.c:
	Enable functionality to have multiple background IO helper threads.
	Expose new configure knobs innodb_read_io_threads and
	innodb_write_io_threads and deprecate innodb_file_io_threads (this
	parameter was relevant only on windows). Internally this allows
	multiple segments for read and write IO request arrays where one
	thread works on one segment.

2009-06-05	The InnoDB Team

	* buf/buf0lru.c, buf/buf0rea.c, handler/ha_innodb.cc,
	include/srv0srv.h, srv/srv0srv.c:
	Fix a bug in linear read ahead:
	  1) Take into account access pattern when deciding whether or not to
	    do linear read ahead.
	  2) Expose a knob innodb_read_ahead_factor = [0-64] default (8),
	    dynamic, global to control linear read ahead behavior. This is the
	    value of the number of pages that InnoDB will tolerate within a
	    64 page extent even if they are accessed out of order or have
	    not been accessed at all. This number (which varies from 0 to 64)
	    is indicative of the slack that we have when deciding about linear
	    readahead.
	  3) Disable random read ahead. Keep the code for now.

2009-06-03	The InnoDB Team

	* dict/dict0dict.c, mysql-test/t/innodb_mysql.test,
	mysql-test/r/innodb_mysql.result:
	Fix Bug#39793 Foreign keys not constructed when column
	has a '#' in a comment or default value

2009-05-27	The InnoDB Team

	* Doxyfile:
	Allow the extraction of documentation from the code base with the
	Doxygen tool. Convert and add many (but not yet all) comments to
	Doxygen format.

2009-05-19	The InnoDB Team

	* btr/btr0btr.c, btr/btr0cur.c, lock/lock0lock.c,
	include/page0page.ic, include/lock0lock.h, include/dict0dict.h,
	include/page0page.h, include/dict0dict.ic, ibuf/ibuf0ibuf.c,
	page/page0zip.c, page/page0page.c:
	Write updates of PAGE_MAX_TRX_ID to the redo log and add debug
	assertions for checking that PAGE_MAX_TRX_ID is valid on leaf
	pages of secondary indexes and the insert buffer B-tree. This bug
	could cause failures in secondary index lookups in consistent
	reads right after crash recovery.

2009-05-18	The InnoDB Team

	* btr/btr0cur.c:
	Correctly estimate the space needed on the compressed page when
	performing an update by delete-and-insert.

2009-05-14	The InnoDB Team

	* handler/ha_innodb.cc, include/srv0srv.h,
	mysql-test/innodb_bug42101-nonzero-master.opt,
	mysql-test/innodb_bug42101-nonzero.result,
	mysql-test/innodb_bug42101-nonzero.test,
	mysql-test/innodb_bug42101.result, mysql-test/innodb_bug42101.test,
	srv/srv0srv.c:
	Fix Bug#42101 Race condition in innodb_commit_concurrency

2009-05-13	The InnoDB Team

	* dict/dict0dict.c:
	Fix Bug#44320 InnoDB: missing DB_ROLL_PTR in Table Monitor COLUMNS
	output

2009-04-29	The InnoDB Team

	* fil/fil0fil.c, include/fil0fil.h, include/mtr0mtr.h,
	log/log0recv.c:
	Fix Bug#41609 Crash recovery does not work for InnoDB temporary tables

2009-04-23	The InnoDB Team

	* row/row0mysql.c:
	When scanning indexes, report in the error log any error codes
	returned by the search function. These error codes will still be
	ignored in CHECK TABLE.

2009-04-23	The InnoDB Team

	* include/trx0types.h:
	Define the logical type names trx_id_t, roll_ptr_t, and undo_no_t
	and use them in place of dulint everywhere.

2009-04-18	The InnoDB Team

	* handler/ha_innodb.cc, include/pars0pars.h:
	Fix Bug#29125 Windows Server X64: so many compiler warnings

2009-04-16	The InnoDB Team

	* include/univ.i:
	Define REFMAN as the base URL of the MySQL Reference Manual and
	use the macro in all diagnostic output.

2009-04-16	The InnoDB Team

	* CMakeLists.txt, include/os0sync.h, include/sync0sync.h,
	include/sync0sync.ic, include/univ.i, srv/srv0start.c,
	sync/sync0sync.c:
	Use the Windows Interlocked functions for atomic memory
	access.

2009-04-15	The InnoDB Team

	* mysql-test/innodb.result, mysql-test/innodb.test:
	Fix Bug#43309 Test main.innodb can't be run twice

2009-04-14	The InnoDB Team

	* CMakeLists.txt, handler/win_delay_loader.cc,
	win-plugin/win-plugin.diff:
	Remove statically linked libraries from MySQL (zlib and strings).

2009-04-11	The InnoDB Team

	* CMakeLists.txt, win-plugin/README, win-plugin/win-plugin.diff:
	Rewrite CMakeLists.txt.

2009-04-07	The InnoDB Team

	* include/os0sync.h, include/sync0rw.ic, include/sync0sync.h,
	include/sync0sync.ic, include/univ.i, plug.in, srv/srv0srv.c,
	srv/srv0start.c, sync/sync0arr.c, sync/sync0sync.c:
	Enable atomics on Solaris (using the libc functions as defined in
	atomic.h) if GCC atomic builtins are not present.

2009-04-07	The InnoDB Team

	* btr/btr0btr.c, dict/dict0dict.c, ibuf/ibuf0ibuf.c,
	include/data0data.h, include/data0data.ic, include/data0type.h,
	include/data0type.ic, include/dict0dict.h, include/dict0dict.ic,
	include/rem0rec.ic, mysql-test/innodb.result, mysql-test/innodb.test,
	pars/pars0pars.c, rem/rem0rec.c, row/row0upd.c:
	Fix Bug#44032 In ROW_FORMAT=REDUNDANT, update UTF-8 CHAR
	to/from NULL is not in-place

2009-04-07	The InnoDB Team

	* page/page0cur.c:
	Fix Bug#43660 SHOW INDEXES/ANALYZE does NOT update cardinality for
	indexes of InnoDB table

2009-04-06	The InnoDB Team

	* handler/ha_innodb.cc:
	Make the parameter innodb_change_buffering settable by the
	configuration file or mysqld command line options. Before this
	fix, the initial value specified for this parameter was ignored.

2009-04-06	The InnoDB Team

	* sync/sync0rw.c:
	Avoid a bogus failure in UNIV_SYNC_DEBUG diagnostics.

2009-04-02	The InnoDB Team

	* handler/ha_innodb.cc, include/srv0srv.h, srv/srv0srv.c:
	Add new parameter innodb_spin_wait_delay to set the maximum delay
	between polling for a spin lock.

2009-04-02	The InnoDB Team

	* dict/dict0crea.c, handler/ha_innodb.cc, handler/ha_innodb.h,
	include/dict0mem.h, include/row0merge.h, include/row0mysql.h,
	mysql-test/innodb-index.result, mysql-test/innodb-index.test,
	row/row0merge.c, row/row0sel.c:
	In consistent reads, refuse to use newly created indexes that may
	lack history.

2009-03-25	The InnoDB Team

	* buf/buf0buf.c, handler/ha_innodb.cc, include/buf0buf.h:
	In SHOW ENGINE INNODB MUTEX do not show the status of block->mutex,
	block->lock, block->lock->mutex (if applicable) and all mutexes and
	rw-locks for which number of os-waits are zero because this can
	be overwhelming particularly when the buffer pool is very large.

2009-03-20	The InnoDB Team

	* buf/buf0buf.c, include/log0recv.h, log/log0recv.c:
	Remove the compile-time constant parameters of
	recv_recover_page(), recv_scan_log_recs(), and recv_sys_init().

2009-03-20	The InnoDB Team

	* data/data0type.c, handler/ha_innodb.cc, include/ha_prototypes.h:
	Declare innobase_get_at_most_n_mbchars() in ha_prototypes.h.

2009-03-20	The InnoDB Team

	* fil/fil0fil.h, fil/fil0fil.c, srv/srv0start.c:
	Add the parameter hash_size to fil_init().

2009-03-20	The InnoDB Team

	* fil/fil0fil.c:
	Refer to fil_system directly, not via local variables.

2009-03-20	The InnoDB Team

	* page/page0page.c:
	In page_validate(), always report the space id, page number and
	the name of the index when corruption is noticed.

2009-03-20	The InnoDB Team

	* include/log0log.h, include/log0log.ic, log/log0log.c:
	Add in/out comments or const qualifiers to some function
	parameters as appropriate.

2009-03-20	The InnoDB Team

	* dict/dict0boot.c, dict/dict0dict.c, fsp/fsp0fsp.c,
	include/dict0dict.h, include/srv0srv.h, srv/srv0srv.c,
	page/page0page.c:
	Replace srv_sys->dummy_ind1 and srv_sys->dummy_ind2 with
	dict_ind_redundant and dict_ind_compact, which are
	initialized by dict_init().

2009-03-11	The InnoDB Team

	InnoDB Plugin 1.0.3 released

2009-03-05	The InnoDB Team

	* handler/ha_innodb.cc, mysql-test/innodb-autoinc.result,
	mysql-test/innodb-autoinc.test:
	Fix Bug#43203 Overflow from auto incrementing causes server segv

2009-02-25	The InnoDB Team

	* handler/ha_innodb.cc, mysql-test/innodb-autoinc.result,
	mysql-test/innodb-autoinc.test:
	Fix Bug#42714 AUTO_INCREMENT errors in 5.1.31

2009-02-23	The InnoDB Team

	* btr/btr0cur.c:
	Fix Bug#43043 Crash on BLOB delete operation

2009-02-20	The InnoDB Team

	* handler/ha_innodb.cc:
	Make innodb_use_sys_malloc=ON the default.

2009-02-20	The InnoDB Team

	* handler/ha_innodb.cc, mysql-test/innodb-autoinc.result,
	mysql-test/innodb-autoinc.test:
	Fix Bug#42400 InnoDB autoinc code can't handle floating-point columns

2009-02-18	The InnoDB Team

	* include/ut0mem.h, os/os0proc.c, ut/ut0mem.c:
	Protect ut_total_allocated_memory with ut_list_mutex in
	os_mem_alloc_large() and os_mem_free_large(). The lack of this mutex
	protection could cause an assertion failure during fast index
	creation. Also, add UNIV_MEM_ALLOC and UNIV_MEM_FREE instrumentation
	to os_mem_alloc_large() and os_mem_free_large(), so that Valgrind can
	detect more errors.

2009-02-11	The InnoDB Team

	* handler/ha_innodb.cc:
	Make innodb_thread_concurrency=0 the default. The old default value
	was 8. A non-zero setting may be useful when InnoDB is showing severe
	scalability problems under multiple concurrent connections.

2009-02-10	The InnoDB Team

	* handler/ha_innodb.cc, handler/ha_innodb.h:
	Fix Bug#41676 Table names are case insensitive in locking

2009-02-10	The InnoDB Team

	* mem/mem0dbg.c, mem/mem0mem.c, mem/mem0pool.c:
	When innodb_use_sys_malloc is set, ignore
	innodb_additional_mem_pool_size, because nothing will be allocated
	from mem_comm_pool.

2009-02-10	The InnoDB Team

	* ut/ut0mem.c:
	Map ut_malloc_low(), ut_realloc(), and ut_free() directly to malloc(),
	realloc(), and free() when innodb_use_sys_malloc is set. As a side
	effect, ut_total_allocated_memory ("Total memory allocated" in the
	"BUFFER POOL AND MEMORY" section of SHOW ENGINE INNODB STATUS) will
	exclude any memory allocated by these functions when
	innodb_use_sys_malloc is set.

2009-02-10	The InnoDB Team

	* btr/btr0cur.c, btr/btr0sea.c, buf/buf0buf.c, handler/ha_innodb.cc,
	include/buf0buf.ic, include/os0sync.h, include/srv0srv.h,
	include/sync0rw.h, include/sync0rw.ic, include/sync0sync.h,
	include/sync0sync.ic, include/univ.i, row/row0sel.c, srv/srv0srv.c,
	srv/srv0start.c, sync/sync0arr.c, sync/sync0rw.c, sync/sync0sync.c:
	On those platforms that support it, implement the synchronization
	primitives of InnoDB mutexes and read/write locks with GCC atomic
	builtins instead of Pthreads mutexes and InnoDB mutexes. These changes
	are based on a patch supplied by Mark Callaghan of Google under a BSD
	license.

2009-01-30	The InnoDB Team

	* btr/btr0cur.c, btr/btr0sea.c, buf/buf0buf.c, handler/ha_innodb.cc,
	include/btr0sea.h, include/buf0buf.h, include/sync0sync.h,
	sync/sync0sync.c:
	Make the configuration parameter innodb_adaptive_hash_index dynamic,
	so that it can be changed at runtime.

2009-01-29	The InnoDB Team

	* handler/ha_innodb.cc, ibuf/ibuf0ibuf.c, include/ibuf0ibuf.h,
	include/ibuf0ibuf.ic:
	Implement the settable global variable innodb_change_buffering,
	with the allowed values 'none' and 'inserts'. The default value
	'inserts' enables the buffering of inserts to non-unique secondary
	index trees when the B-tree leaf page is not in the buffer pool.

2009-01-27	The InnoDB Team

	* buf/buf0lru.c:
	Fix a race condition in buf_LRU_invalidate_tablespace(): The
	compressed page size (zip_size) was read while the block descriptor
	was no longer protected by a mutex. This could lead to corruption
	when a table is dropped on a busy system that contains compressed
	tables.

2009-01-26	The InnoDB Team

	* btr/btr0sea.c, buf/buf0buf.c, include/buf0buf.h, include/buf0buf.ic,
	include/mtr0log.ic, include/row0upd.ic, mtr/mtr0mtr.c:
	Implement buf_block_align() with pointer arithmetics, as it is in the
	built-in InnoDB distributed with MySQL. Do not acquire the buffer pool
	mutex before buf_block_align(). This removes a scalability bottleneck
	in the adaptive hash index lookup. In CHECK TABLE, check that
	buf_pool->page_hash is consistent with buf_block_align().

2009-01-23	The InnoDB Team

	* btr/btr0sea.c:
	Fix Bug#42279 Race condition in btr_search_drop_page_hash_when_freed()

2009-01-23	The InnoDB Team

	* buf/buf0buf.c, include/buf0buf.h:
	Remove the unused mode BUF_GET_NOWAIT of buf_page_get_gen()

2009-01-20	The InnoDB Team

	* include/rem0rec.h, include/rem0rec.ic:
	Fix Bug#41571 MySQL segfaults after innodb recovery

2009-01-20	The InnoDB Team

	* lock/lock0lock.c:
	Fix Bug#42152 Race condition in lock_is_table_exclusive()

2009-01-14	The InnoDB Team

	* include/trx0roll.h, trx/trx0roll.c, trx/trx0trx.c:
	Fix Bug#38187 Error 153 when creating savepoints

2009-01-14	The InnoDB Team

	* dict/dict0load.c:
	Fix Bug#42075 dict_load_indexes failure in dict_load_table will
	corrupt the dictionary cache

2009-01-13	The InnoDB Team

	* buf/buf0buddy.c, dict/dict0dict.c, dict/dict0mem.c, fil/fil0fil.c,
	ha/ha0storage.c, handler/ha_innodb.cc, handler/win_delay_loader.cc,
	include/buf0buf.ic, include/dict0dict.ic, include/hash0hash.h,
	thr/thr0loc.c, trx/trx0i_s.c:
	Add the parameter ASSERTION to HASH_SEARCH() macro, and use it for
	light validation of the traversed items in hash table lookups when
	UNIV_DEBUG is enabled.

2009-01-09	The InnoDB Team

	* buf/buf0flu.c, include/buf0flu.h, include/buf0flu.ic:
	Remove unused code from the functions
	buf_flush_insert_into_flush_list() and
	buf_flush_insert_sorted_into_flush_list().

2009-01-09	The InnoDB Team

	* buf/buf0flu.c:
	Simplify the functions buf_flush_try_page() and buf_flush_batch(). Add
	debug assertions and an explanation to buf_flush_write_block_low().

2009-01-07	The InnoDB Team

	* row/row0merge.c:
	Fix a bug in recovery when dropping temporary indexes.

2009-01-07	The InnoDB Team

	* handler/ha_innodb.cc, handler/ha_innodb.h, handler/handler0alter.cc:
	Fix Bug#41680 calls to trx_allocate_for_mysql are not consistent

2009-01-07	The InnoDB Team

	* mysql-test/innodb_bug41904.result, mysql-test/innodb_bug41904.test,
	row/row0merge.c:
	Fix Bug#41904 create unique index problem

2009-01-02	The InnoDB Team

	* handler/ha_innodb.cc, include/srv0srv.h, mem/mem0pool.c,
	mysql-test/innodb-use-sys-malloc-master.opt,
	mysql-test/innodb-use-sys-malloc.result,
	mysql-test/innodb-use-sys-malloc.test, srv/srv0srv.c, srv/srv0start.c:
	Implement the configuration parameter innodb_use_sys_malloc (false by
	default), for disabling InnoDB's internal memory allocator and using
	system malloc/free instead. The "BUFFER POOL AND MEMORY" section of
	SHOW ENGINE INNODB STATUS will report "in additional pool allocated
	allocated 0" when innodb_use_sys_malloc is set.

2008-12-30	The InnoDB Team

	* btr/btr0btr.c:
	When setting the PAGE_LEVEL of a compressed B-tree page from or to 0,
	compress the page at the same time. This is necessary, because the
	column information stored on the compressed page will differ between
	leaf and non-leaf pages. Leaf pages are identified by PAGE_LEVEL=0.
	This bug can make InnoDB crash when all rows of a compressed table are
	deleted.

2008-12-17	The InnoDB Team

	* include/row0sel.h, include/row0upd.h, pars/pars0pars.c,
	row/row0mysql.c, row/row0sel.c, row/row0upd.c:
	Remove update-in-place select from the internal SQL interpreter. It
	was only used for updating the InnoDB internal data dictionary when
	renaming or dropping tables. It could have caused deadlocks when
	acquiring latches on insert buffer bitmap pages.

2008-12-17	The InnoDB Team

	* btr/btr0sea.c, buf/buf0buf.c, buf/buf0lru.c, ha/ha0ha.c,
	ha/hash0hash.c, include/buf0buf.h, include/ha0ha.h, include/ha0ha.ic,
	include/hash0hash.h, include/univ.i:
	Introduce the preprocessor symbol UNIV_AHI_DEBUG for enabling adaptive
	hash index debugging independently of UNIV_DEBUG.

2008-12-16	The InnoDB Team

	* btr/btr0cur.c:
	Do not update the free bits in the insert buffer bitmap when inserting
	or deleting from the insert buffer B-tree. Assert that records in the
	insert buffer B-tree are never updated.

2008-12-12	The InnoDB Team

	* buf/buf0buf.c, fil/fil0fil.c, fsp/fsp0fsp.c, ibuf/ibuf0ibuf.c,
	include/fil0fil.h, include/ibuf0ibuf.h, include/ibuf0ibuf.ic,
	include/ibuf0types.h:
	Clean up the insert buffer subsystem so that only one insert
	buffer B-tree exists.
	Originally, there were provisions in InnoDB for multiple insert
	buffer B-trees, apparently one for each tablespace.
	When Heikki Tuuri implemented multiple InnoDB tablespaces in
	MySQL/InnoDB 4.1, he made the insert buffer live only in the
	system tablespace (space 0) but left the provisions in the code.

2008-12-11	The InnoDB Team

	* include/srv0srv.h, os/os0proc.c, srv/srv0srv.c:
	Fix the issue that the InnoDB plugin fails if innodb_buffer_pool_size
	is defined bigger than 4096M on 64-bit Windows. This bug should not
	have affected other 64-bit systems.

2008-12-09	The InnoDB Team

	* handler/ha_innodb.cc:
	Fix Bug#40386 Not flushing query cache after truncate.

2008-12-09	The InnoDB Team

	* handler/ha_innodb.cc, srv/srv0srv.c, trx/trx0trx.c:
	Fix Bug#40760 "set global innodb_thread_concurrency = 0;" is not safe

2008-12-04	The InnoDB Team

	* handler/ha_innodb.cc, handler/mysql_addons.cc,
	include/mysql_addons.h, trx/trx0i_s.c, win-plugin/win-plugin.diff:
	Remove dependencies to MySQL internals (defining MYSQL_SERVER).

2008-12-02	The InnoDB Team

	* page/page0cur.c:
	When allocating space for a record from the free list of previously
	purged records, zero out the DB_TRX_ID and DB_ROLL_PTR of the purged
	record if the new record would not overwrite these fields. This fixes
	a harmless content mismatch reported by page_zip_validate().

2008-12-02	The InnoDB Team

	* row/row0merge.c:
	Replace the WHILE 1 with WHILE 1=1 in the SQL procedure, so that the
	loop will actually be entered and temporary indexes be dropped during
	crash recovery.

2008-12-01	The InnoDB Team

	InnoDB Plugin 1.0.2 released

2008-10-31	The InnoDB Team

	* dict/dict0mem.c, include/dict0mem.h, include/lock0lock.h,
	include/row0mysql.h, include/trx0trx.h, include/univ.i,
	include/ut0vec.h, include/ut0vec.ic, lock/lock0lock.c,
	row/row0mysql.c, trx/trx0trx.c:
	Fix Bug#26316 Triggers create duplicate entries on auto-increment
	columns

2008-10-30	The InnoDB Team

	* handler/ha_innodb.cc, handler/handler0vars.h,
	handler/win_delay_loader.cc, mysql-test/innodb_bug40360.result,
	mysql-test/innodb_bug40360.test:
	Fix Bug#40360 Binlog related errors with binlog off

2008-10-29	The InnoDB Team

	* include/data0type.ic:
	Fix Bug#40369 dtype_get_sql_null_size() returns 0 or 1, not the size

2008-10-29	The InnoDB Team

	* handler/ha_innodb.cc, include/srv0srv.h, srv/srv0srv.c:
	Fix Bug#38189 innodb_stats_on_metadata missing

2008-10-28	The InnoDB Team

	* CMakeLists.txt, ha_innodb.def, handler/ha_innodb.cc,
	handler/handler0alter.cc, handler/handler0vars.h, handler/i_s.cc,
	handler/win_delay_loader.cc, win-plugin/*:
	Implemented the delayloading of externals for the plugin on Windows.
	This makes it possible to build a dynamic plugin (ha_innodb.dll) on
	Windows.

2008-10-27	The InnoDB Team

	* CMakeLists.txt:
	Fix Bug#19424 InnoDB: Possibly a memory overrun of the buffer being
	freed (64-bit Visual C)

2008-10-23	The InnoDB Team

	* ibuf/ibuf0ibuf.c:
	ibuf_delete_rec(): When the cursor to the insert buffer record
	cannot be restored, do not complain if the tablespace does not
	exist, because the insert buffer record may have been discarded by
	some other thread. This bug has existed in MySQL/InnoDB since
	version 4.1, when innodb_file_per_table was implemented.
	This may fix Bug#27276 InnoDB Error: ibuf cursor restoration fails.

2008-10-22	The InnoDB Team

	* dict/dict0dict.c, dict/dict0mem.c, handler/ha_innodb.cc,
	handler/ha_innodb.h, include/dict0dict.h, include/dict0mem.h,
	row/row0mysql.c:
	Fix Bug#39830 Table autoinc value not updated on first insert
	Fix Bug#35498 Cannot get table test/table1 auto-inccounter value in
	::info
	Fix Bug#36411 "Failed to read auto-increment value from storage
	engine" in 5.1.24 auto-inc

2008-10-22	The InnoDB Team

	* handler/ha_innodb.cc, include/row0mysql.h, row/row0mysql.c:
	Fix Bug#40224 New AUTOINC changes mask reporting of deadlock/timeout
	errors

2008-10-16	The InnoDB Team

	* dict/dict0dict.c, mysql-test/innodb-index.result,
	mysql-test/innodb-index.test:
	Skip the undo log size check when creating REDUNDANT and COMPACT
	tables. In ROW_FORMAT=DYNAMIC and ROW_FORMAT=COMPRESSED, column
	prefix indexes require that prefixes of externally stored columns
	be written to the undo log. This may make the undo log record
	bigger than the record on the B-tree page. The maximum size of an
	undo log record is the page size. That must be checked for, in
	dict_index_add_to_cache(). However, this restriction must not
	be enforced on REDUNDANT or COMPACT tables.

2008-10-15	The InnoDB Team

	* btr/btr0cur.c, include/btr0cur.h, row/row0ext.c, row/row0sel.c,
	row/row0upd.c:
	When the server crashes while freeing an externally stored column
	of a compressed table, the BTR_EXTERN_LEN field in the BLOB
	pointer will be written as 0. Tolerate this in the functions that
	deal with externally stored columns. This fixes problems after
	crash recovery, in the rollback of incomplete transactions, and in
	the purge of delete-marked records.

2008-10-15	The InnoDB Team

	* btr/btr0btr.c, include/page0zip.h, page/page0zip.c, include/univ.i:
	When a B-tree node of a compressed table is split or merged, the
	compression may fail. In this case, the entire compressed page
	will be copied and the excess records will be deleted. However,
	page_zip_copy(), now renamed to page_zip_copy_recs(), copied too
	many fields in the page header, overwriting PAGE_BTR_SEG_LEAF and
	PAGE_BTR_SEG_TOP when splitting the B-tree root. This caused
	corruption of compressed tables. Furthermore, the lock table and
	the adaptive hash index would be corrupted, because we forgot to
	update them when invoking page_zip_copy_recs().

	Introduce the symbol UNIV_ZIP_DEBUG for triggering the copying of
	compressed pages more often, for debugging purposes.

2008-10-10	The InnoDB Team

	* handler/handler0alter.cc, include/row0merge.h, row/row0merge.c,
	row/row0mysql.c:
	Fix some locking issues, mainly in fast index creation. The
	InnoDB data dictionary cache should be latched whenever a
	transaction is holding locks on any data dictionary tables.
	Otherwise, lock waits or deadlocks could occur. Furthermore, the
	data dictionary transaction must be committed (and the locks
	released) before the data dictionary latch is released.

	ha_innobase::add_index(): Lock the data dictionary before renaming
	or dropping the created indexes, because neither operation will
	commit the data dictionary transaction.

	ha_innobase::final_drop_index(): Commit the transactions before
	unlocking the data dictionary.

2008-10-09	The InnoDB Team

	* buf/buf0lru.c:
	Fix Bug#39939 DROP TABLE/DISCARD TABLESPACE takes long time in
	buf_LRU_invalidate_tablespace()

2008-10-08	The InnoDB Team

	* dict/dict0crea.c, trx/trx0roll.c, include/row0mysql.h,
	row/row0merge.c, row/row0mysql.c:
	When dropping a table, hold the data dictionary latch until the
	transaction has been committed. The data dictionary latch is
	supposed to prevent lock waits and deadlocks in the data
	dictionary tables. Due to this bug, DROP TABLE could cause a
	deadlock or hang. Note that because of Bug#33650 and Bug#39833,
	MySQL may also drop a (temporary) table when executing CREATE INDEX
	or ALTER TABLE ... ADD INDEX.

2008-10-04	The InnoDB Team

	* handler/ha_innodb.cc, mysql-test/innodb_bug39438-master.opt,
	mysql-test/innodb_bug39438.result, mysql-test/innodb_bug39438.test:
	Fix Bug#39438 Testcase for Bug#39436 crashes on 5.1 in
	fil_space_get_latch

2008-10-04	The InnoDB Team

	* include/lock0lock.h, lock/lock0lock.c,
	mysql-test/innodb_bug38231.result, mysql-test/innodb_bug38231.test,
	row/row0mysql.c:
	Fix Bug#38231 Innodb crash in lock_reset_all_on_table() on TRUNCATE +
	LOCK / UNLOCK

2008-10-04	The InnoDB Team

	* handler/ha_innodb.cc:
	Fix Bug#35498 Cannot get table test/table1 auto-inccounter value in
	::info

2008-10-04	The InnoDB Team

	* handler/ha_innodb.cc, handler/ha_innodb.h:
	Fix Bug#37788 InnoDB Plugin: AUTO_INCREMENT wrong for compressed
	tables

2008-10-04	The InnoDB Team

	* dict/dict0dict.c, handler/ha_innodb.cc, handler/ha_innodb.h,
	include/dict0dict.h, include/dict0mem.h, row/row0mysql.c:
	Fix Bug#39830 Table autoinc value not updated on first insert

2008-10-03	The InnoDB Team

	* mysql-test/innodb-index.test, mysql-test/innodb-index.result,
	mysql-test/innodb-timeout.test, mysql-test/innodb-timeout.result,
	srv/srv0srv.c, include/srv0srv.h, handler/ha_innodb.cc,
	include/ha_prototypes.h:
	Fix Bug#36285 innodb_lock_wait_timeout is not dynamic, not per session

2008-09-19	The InnoDB Team

	* os/os0proc.c:
	Fix a memory leak on Windows. The memory leak was due to wrong
	parameters passed into VirtualFree() call. As the result, the
	call fails with Windows error 87.

2008-09-17	The InnoDB Team

	* mysql-test/innodb.result, mysql-test/innodb-zip.result,
	mysql-test/innodb-zip.test, mysql-test/innodb.test, ibuf/ibuf0ibuf.c,
	dict/dict0crea.c, dict/dict0load.c, dict/dict0boot.c,
	include/dict0dict.h, include/trx0trx.h, dict/dict0dict.c,
	trx/trx0trx.c, include/ha_prototypes.h, handler/ha_innodb.cc:
	When creating an index in innodb_strict_mode, check that the
	maximum record size will never exceed the B-tree page size limit.
	For uncompressed tables, there should always be enough space for
	two records in an empty B-tree page. For compressed tables, there
	should be enough space for storing two node pointer records or one
	data record in an empty page in uncompressed format.
	The purpose of this check is to guarantee that INSERT or UPDATE
	will never fail due to too big record size.

2008-09-17	The InnoDB Team

	* btr/btr0cur.c, data/data0data.c, include/page0zip.h,
	include/page0zip.ic, page/page0zip.c, mysql-test/innodb_bug36172.test:
	Prevent infinite B-tree page splits in compressed tables by
	ensuring that there will always be enough space for two node
	pointer records in an empty B-tree page. Also, require that at
	least one data record will fit in an empty compressed page. This
	will reduce the maximum size of records in compressed tables.

2008-09-09	The InnoDB Team

	* mysql-test/innodb.result:
	Fix the failing innodb test by merging changes that MySQL made to
	that file (r2646.12.1 in MySQL BZR repository)

2008-09-09	The InnoDB Team

	* handler/ha_innodb.cc, mysql-test/innodb-autoinc.result,
	mysql-test/innodb-autoinc.test:
	Fix Bug#38839 auto increment does not work properly with InnoDB after
	update

2008-09-09	The InnoDB Team

	* dict/dict0dict.c, handler/handler0alter.cc, include/dict0dict.h,
	mysql-test/innodb-index.result, mysql-test/innodb-index.test:
	Fix Bug#38786 InnoDB plugin crashes on drop table/create table with FK

2008-08-21	The InnoDB Team

	* handler/ha_innodb.cc, include/ha_prototypes.h, row/row0sel.c:
	Fix Bug#37885 row_search_for_mysql may gap lock unnecessarily with SQL
	comments in query

2008-08-21	The InnoDB Team

	* handler/ha_innodb.cc:
	Fix Bug#38185 ha_innobase::info can hold locks even when called with
	HA_STATUS_NO_LOCK

2008-08-18	The InnoDB Team

	* buf/buf0buf.c, buf/buf0lru.c, include/buf0buf.ic, include/univ.i:
	Introduce UNIV_LRU_DEBUG for debugging the LRU buffer pool cache

2008-08-08	The InnoDB Team

	* buf/buf0lru.c, include/buf0buf.h:
	Fix two recovery bugs that could lead to a crash in debug builds with
	small buffer size

2008-08-07	The InnoDB Team

	* btr/btr0cur.c, handler/ha_innodb.cc, include/srv0srv.h,
	srv/srv0srv.c:
	Add a parameter innodb_stats_sample_pages to allow users to control
	the number of index dives when InnoDB estimates the cardinality of
	an index (ANALYZE TABLE, SHOW TABLE STATUS etc)

2008-08-07	The InnoDB Team

	* trx/trx0i_s.c:
	Fix a bug that would lead to a crash if a SELECT was issued from the
	INFORMATION_SCHEMA tables and there are rolling back transactions at
	the same time

2008-08-06	The InnoDB Team

	* btr/btr0btr.c, btr/btr0cur.c, ibuf/ibuf0ibuf.c, include/btr0cur.h,
	include/trx0roll.h, include/trx0types.h, row/row0purge.c,
	row/row0uins.c, row/row0umod.c, trx/trx0roll.c:
	In the rollback of incomplete transactions after crash recovery,
	tolerate clustered index records whose externally stored columns
	have not been written.

2008-07-30	The InnoDB Team

	* trx/trx0trx.c:
	Fixes a race in recovery where the recovery thread recovering a
	PREPARED trx and the background rollback thread can both try
	to free the trx after its status is set to COMMITTED_IN_MEMORY.

2008-07-29	The InnoDB Team

	* include/trx0rec.h, row/row0purge.c, row/row0vers.c, trx/trx0rec.c:
	Fix a BLOB corruption bug

2008-07-15	The InnoDB Team

	* btr/btr0sea.c, dict/dict0dict.c, include/btr0sea.h:
	Fixed a timing hole where a thread dropping an index can free the
	in-memory index struct while another thread is still using that
	structure to remove entries from adaptive hash index belonging
	to one of the pages that belongs to the index being dropped.

2008-07-04	The InnoDB Team

	* mysql-test/innodb-index.result:
	Fix the failing innodb-index test by adjusting the result to a new
	MySQL behavior (the change occured in BZR-r2667)

2008-07-03	The InnoDB Team

	* mysql-test/innodb-zip.result, mysql-test/innodb-zip.test:
	Remove the negative test cases that produce warnings

2008-07-02	The InnoDB Team

	* mysql-test/innodb-replace.result, mysql-test/innodb-index.test:
	Disable part of innodb-index test because MySQL changed its behavior
	and is not calling ::add_index() anymore when adding primary index on
	non-NULL column

2008-07-01	The InnoDB Team

	* mysql-test/innodb-replace.result, mysql-test/innodb-replace.test:
	Fix the failing innodb-replace test by merging changes that MySQL
	made to that file (r2659 in MySQL BZR repository)

2008-07-01	The InnoDB Team

	* lock/lock0lock.c:
	Fix Bug#36942 Performance problem in lock_get_n_rec_locks (SHOW INNODB
	STATUS)

2008-07-01	The InnoDB Team

	* ha/ha0ha.c:
	Fix Bug#36941 Performance problem in ha_print_info (SHOW INNODB
	STATUS)

2008-07-01	The InnoDB Team

	* handler/ha_innodb.cc, mysql-test/innodb-autoinc.result,
	mysql-test/innodb-autoinc.test:
	Fix Bug#37531 After truncate, auto_increment behaves incorrectly for
	InnoDB

2008-06-19	The InnoDB Team

	* handler/ha_innodb.cc:
	Rewrite the function innodb_plugin_init() to support parameters in
	different order (in static and dynamic InnoDB) and to support more
	parameters in the static InnoDB

2008-06-19	The InnoDB Team

	* handler/handler0alter.cc:
	Fix a bug in ::add_index() which set the transaction state to "active"
	but never restored it to the original value. This bug caused warnings
	to be printed by the rpl.rpl_ddl mysql-test.

2008-06-19	The InnoDB Team

	* mysql-test/patches:
	Add a directory which contains patches, which need to be applied to
	MySQL source in order to get some mysql-tests to succeed. The patches
	cannot be committed in MySQL repository because they are specific to
	the InnoDB plugin.

2008-06-19	The InnoDB Team

	* mysql-test/innodb-zip.result, mysql-test/innodb-zip.test,
	row/row0row.c:
	Fix an anomaly when updating a record with BLOB prefix

2008-06-18	The InnoDB Team

	* include/trx0sys.h, srv/srv0start.c, trx/trx0sys.c:
	Fix a bug in recovery which was a side effect of the file_format_check
	changes

2008-06-09	The InnoDB Team

	* mysql-test/innodb.result:
	Fix the failing innodb test by merging changes that MySQL made to that
	file

2008-06-06	The InnoDB Team

	* buf/buf0buf.c, handler/ha_innodb.cc, include/buf0buf.h,
	include/srv0srv.h, srv/srv0srv.c:
	Fix Bug#36600 SHOW STATUS takes a lot of CPU in
	buf_get_latched_pages_number

	* handler/ha_innodb.cc, os/os0file.c:
	Fix Bug#11894 innodb_file_per_table crashes w/ Windows .sym symbolic
	link hack

	* include/ut0ut.h, srv/srv0srv.c, ut/ut0ut.c:
	Fix Bug#36819 ut_usectime does not handle errors from gettimeofday

	* handler/ha_innodb.cc:
	Fix Bug#35602 Failed to read auto-increment value from storage engine

	* srv/srv0start.c:
	Fix Bug#36149 Read buffer overflow in srv0start.c found during "make
	test"

2008-05-08	The InnoDB Team

	* btr/btr0btr.c, mysql-test/innodb_bug36172.result,
	mysql-test/innodb_bug36172.test:
	Fix Bug#36172 insert into compressed innodb table crashes

2008-05-08	The InnoDB Team

	InnoDB Plugin 1.0.1 released

2008-05-06	The InnoDB Team

	* handler/ha_innodb.cc, include/srv0srv.h, include/sync0sync.h,
	include/trx0sys.h, mysql-test/innodb-zip.result,
	mysql-test/innodb-zip.test, srv/srv0srv.c, srv/srv0start.c,
	sync/sync0sync.c, trx/trx0sys.c:
	Implement the system tablespace tagging

	* handler/ha_innodb.cc, handler/i_s.cc, include/univ.i,
	srv/srv0start.c:
	Add InnoDB version in INFORMATION_SCHEMA.PLUGINS.PLUGIN_VERSION,
	in the startup message and in a server variable innodb_version.

	* sync/sync0sync.c:
	Fix a bug in the sync debug code where a lock with level
	SYNC_LEVEL_VARYING would cause an assertion failure when a thread
	tried to release it.

2008-04-30	The InnoDB Team

	* Makefile.am:
	Fix Bug#36434 ha_innodb.so is installed in the wrong directory

	* handler/ha_innodb.cc:
	Merge change from MySQL (Fix Bug#35406 5.1-opt crashes on select from
	I_S.REFERENTIAL_CONSTRAINTS):
	ChangeSet@1.2563, 2008-03-18 19:42:04+04:00, gluh@mysql.com +1 -0

	* scripts/install_innodb_plugins.sql:
	Added

	* mysql-test/innodb.result:
	Merge change from MySQL (this fixes the failing innodb test):
	ChangeSet@1.1810.3601.4, 2008-02-07 02:33:21+04:00

	* row/row0sel.c:
	Fix Bug#35226 RBR event crashes slave

	* handler/ha_innodb.cc:
	Change the fix for Bug#32440 to show bytes instead of kilobytes in
	INFORMATION_SCHEMA.TABLES.DATA_FREE

	* handler/ha_innodb.cc, mysql-test/innodb.result,
	mysql-test/innodb.test:
	Fix Bug#29507 TRUNCATE shows to many rows effected

	* handler/ha_innodb.cc, mysql-test/innodb.result,
	mysql-test/innodb.test:
	Fix Bug#35537 Innodb doesn't increment handler_update and
	handler_delete

2008-04-29	The InnoDB Team

	* handler/i_s.cc, include/srv0start.h, srv/srv0start.c:
	Fix Bug#36310 InnoDB plugin crash

2008-04-23	The InnoDB Team

	* mysql-test/innodb_bug36169.result, mysql-test/innodb_bug36169.test,
	row/row0mysql.c:
	Fix Bug#36169 create innodb compressed table with too large row size
	crashed

	* (outside the source tree):
	Fix Bug#36222 New InnoDB plugin 1.0 has wrong MKDIR_P defined in
	Makefile.in

2008-04-15	The InnoDB Team

	InnoDB Plugin 1.0.0 released
